'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');
var lint = require('@codemirror/lint');
var view = require('@codemirror/view');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "#`OVQPOOOVQPO'#ClQhQPOOOOQO'#Ck'#CkOmQPO'#CkOrQPO,59WOVQPO,59XOzQPO'#CeOOQO,59V,59VOOQO1G.r1G.rOOQO1G.s1G.sO!RQPO'#CnO!^QPO,59POVQPO'#CgO!cQPO,59YOOQO1G.k1G.kO!kQPO,59ROOQO-E6e-E6e",
  stateData: "!y~O^OS~OQRORROSROTPOWSO~OVUO~OTVO~OUXOVUO~OUbP~PVOVUOY]OUbX~OU_O~OY]OUba~OVUOUZaYZa~OVR~",
  goto: "!WcPPPPPPPPPdPgPPPm||!TRWSQ^ZRa^QQOQTPQYUQZVR`]ZROPUV]R[V",
  nodeNames: "⚠ NuFormula String Number Item ( ) Operator Keyword ArgList Comma",
  maxTerm: 18,
  nodeProps: [
    ["closedBy", 5,")"],
    ["openedBy", 6,"("]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: ")t~RcXY!^YZ!^]^!^pq!^rs!cxy${yz%Qz{%V{|%[|}&Q}!O%[!O!P%g!P!Q%V!Q![%u!^!_&V!_!`%V!`!a&b!c!}&j#o#p&r~!cO^~~!fWpq!cqr!crs#Os#O!c#O#P#T#P;'S!c;'S;=`$u<%lO!c~#TOQ~~#WXrs!c!P!Q!c#O#P!c#U#V!c#Y#Z!c#b#c!c#f#g!c#h#i!c#i#j#s~#vR!Q![$P!c!i$P#T#Z$P~$SR!Q![$]!c!i$]#T#Z$]~$`R!Q![$i!c!i$i#T#Z$i~$lR!Q![!c!c!i!c#T#Z!c~$xP;=`<%l!c~%QOT~~%VOU~~%[OV~~%aQV~!O!P%g!Q![%u~%jP!Q![%m~%rPR~!Q![%m~%zQR~!O!P%m!Q![%u~&VOY~~&[QV~!_!`%V!`!a%V~&gPV~!_!`%V~&oPW~!c!}&j~&uR!Q!['O!c!i'O#T#Z'O~'RS}!O'_!Q!['O!c!i'O#T#Z'O~'bR!Q!['k!c!i'k#T#Z'k~'nS}!O'z!Q!['k!c!i'k#T#Z'k~'}R!Q![(W!c!i(W#T#Z(W~(ZS}!O(g!Q![(W!c!i(W#T#Z(W~(jR!Q![(s!c!i(s#T#Z(s~(vS}!O)S!Q![(s!c!i(s#T#Z(s~)VR!Q![)`!c!i)`#T#Z)`~)cS!Q![)`!c!i)`#T#Z)`#q#r)o~)tOS~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 84
});

/**
 * 輸出 表單元件 decoration 插件
 *
 * @param {object} formItems - 所有表單元件
 * @returns {ViewPlugin}
 */
function itemWidget(formItems) {
    // 表單項目單元
    class ItemWidget extends view.WidgetType {
        constructor(item) {
            var _a;
            super();
            this.text = (_a = item.options) === null || _a === void 0 ? void 0 : _a.label;
        }
        toDOM() {
            let wrap = document.createElement("span");
            wrap.style.cssText = `
          border-radius: 4px;
          color: #6e7796;
          padding: 2px 4px;
          background-color: #e9ebf2;
        `;
            wrap.innerText = this.text;
            return wrap;
        }
        ignoreEvent() {
            return false;
        }
    }
    /**
     *
     * @param view
     */
    function itemTag(view$1) {
        let widgets = [];
        for (let { from, to } of view$1.visibleRanges) {
            language.syntaxTree(view$1.state).iterate({
                from,
                to,
                enter: (node) => {
                    var _a;
                    if (node.name == "Item") {
                        const itemSn = view$1.state.doc.sliceString(node.from + 1, node.to - 1);
                        const item = (_a = formItems[itemSn]) !== null && _a !== void 0 ? _a : {};
                        let deco = view.Decoration.widget({
                            widget: new ItemWidget(item),
                            side: 1,
                        });
                        widgets.push(deco.range(node.to));
                    }
                },
            });
        }
        return view.Decoration.set(widgets);
    }
    return view.ViewPlugin.fromClass(class {
        constructor(view) {
            this.decorations = itemTag(view);
        }
        update(update) {
            if (update.docChanged || update.viewportChanged)
                this.decorations = itemTag(update.view);
        }
    }, {
        decorations: (instance) => instance.decorations,
        provide: (plugin) => view.EditorView.atomicRanges.of((view$1) => {
            var _a;
            return ((_a = view$1.plugin(plugin)) === null || _a === void 0 ? void 0 : _a.decorations) || view.Decoration.none;
        }),
    });
}

// 輸出 linter
const regexpLinter = () => {
    return lint.linter((view) => {
        let diagnostics = [];
        language.syntaxTree(view.state)
            .cursor()
            .iterate((node) => {
            if (node.type.isError) {
                diagnostics.push({
                    from: node.from,
                    to: node.to,
                    severity: "error",
                    message: node.name,
                });
            }
        });
        return diagnostics;
    }, {
        tooltipFilter: () => [],
    });
};
// 定義語言
const NuformulaLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            highlight.styleTags({
                Keyword: highlight.tags.keyword,
                String: highlight.tags.string,
                Number: highlight.tags.number,
                Operator: highlight.tags.operator,
                Item: highlight.tags.variableName,
                "( )": highlight.tags.paren,
                Comma: highlight.tags.separator,
            }),
        ],
    }),
});
// 語言標籤樣式
const nuformulaHighlightStyle = language.HighlightStyle.define([
    { tag: highlight.tags.keyword, color: "#B157D0" },
    { tag: highlight.tags.string, color: "#F7A452" },
    { tag: highlight.tags.number, color: "#5C9CE5" },
    { tag: highlight.tags.operator, color: "#404040" },
    { tag: highlight.tags.variableName, color: "#6E7796", display: "none" },
]);
// 輸出語言
function nuformula() {
    return new language.LanguageSupport(NuformulaLanguage);
}

exports.NuformulaLanguage = NuformulaLanguage;
exports.itemWidget = itemWidget;
exports.nuformula = nuformula;
exports.nuformulaHighlightStyle = nuformulaHighlightStyle;
exports.regexpLinter = regexpLinter;
